
print("Starting LUA")

local ffi = require("ffi");
ffi.cdef[[
typedef struct
{
    int (*GetKey) (int KeyCode);
    int (*GetJoyButton) (int JoyID,int ButtonCode);
    float (*GetJoyAxis) (int JoyID,int AxisCode);
} API_struct;
]]

PhoAPI = ffi.cast("API_struct*",Get_API());




MaxInstances=50

VRAM_Instances(MaxInstances+2); -- <-- The floor is an instance too.
VRAM_Buffers(1000);

NPCOFFSET = (8+4);

Character_model =Model_add("Trailer.iqm");
Minigun_model = Model_add("minigun.iqm");
Body_model = Model_add("TPJ2.iqm");
mami = Model_add("Mommy.iqm");
--Character_anim = Animation_add("body_Walk.iqm");



Minigun =VRAM_Instance_Create(1,Minigun_model);
Model = VRAM_Instance_Create(0,Character_model);
Instance_Animations_Set_Capacity(Model,1);
Instance_Set_Animation(Model,0,Character_anim,0);
Instance_Animation_Set_Loop(Model,0,true);
Instance_Animation_Set_Interpolation(Model,0,true);


PLAYERSPAWN ={-0.720056,7.37567};


Jugador = Entity_Create(0,PLAYERSPAWN[1],PLAYERSPAWN[2],90+10,0.03,4,0.1,Script_This(),"PC",Model,0.004);
Minigun = Entity_Create(1, PLAYERSPAWN[1],PLAYERSPAWN[2] ,90+10,0.03,0,0.1,nil,nil,Minigun,0.004);

Scene_Set_Map("Path.stl");



function spawnpipol(x,y,deg,id,buffer) 

local npcmodel = VRAM_Instance_Create(buffer,Body_model);
    return  Entity_Create(id, x,y, deg,0.018,0,0.04,Script_This(),"NPC",npcmodel,0.002);
end
 
function  spawnf(x,y,deg,id,buffer,model)
    
local npcmodel = VRAM_Instance_Create(buffer,model);
    return  Entity_Create(id, x,y, deg,0.018,0,0.04,Script_This(),"FAMILY",npcmodel,0.002);
end



NPCSPAWN={

{1.81034,5.27513},

{5.92525,5.64345},

{2.68249,3.77158},

{5.85123,0.73735},

{7.39213,
-4.96179},

{-3.78593,
-4.40413},

{-6.26834,
-3.55226},

{-2.87625,
4.27030},

{-4.59392
,7.44965},

{-2.70943,6.72476},

{-1.68115,2.82297},

{1.95130,-3.36625},

{0.24997,-7.31181},

{-5.57173,-7.41514},

{-6.27577,0.21740}
}

FSPAWN =
{
{6.61465,7.40530}
,
{4.29292,-0.27777}
,
{3.24298,-6.72736}
,
{-3.34056,-3.74525}
,
{-4.83065,1.22211}
,
{-7.41395,-4.53695}
}

NPCMAX = 14
for i = 0,NPCMAX do
    spawnpipol(NPCSPAWN[i+1][1],NPCSPAWN[i+1][2],0,10+i,NPCOFFSET+i)
end

    VRAM_Buffer_fill(NPCOFFSET,NPCOFFSET,NPCOFFSET+NPCMAX,0);




City = Model_add("mapeado/ciudad.iqm");
Casas1 = Model_add("mapeado/casas1.iqm");
Casas2 = Model_add("mapeado/casas2.iqm");
Casas3 = Model_add("mapeado/casas3.iqm");
Street = Model_add("mapeado/calle.iqm");
muro = Model_add("mapeado/muro.iqm");

VRAM_Instance_Create(2,City);
VRAM_Instance_Create(3,Street);
VRAM_Instance_Create(4,muro);
VRAM_Instance_Create(5,Casas1);
VRAM_Instance_Create(6,Casas2);
VRAM_Instance_Create(7,Casas3);

VRAM_Buffer_fill(0,0,0,0);
VRAM_Buffer_fill(1,1,1,0);

for i=2,7 do
    VRAM_Buffer_fill(i,i,i,0);
end



SetBufferTexture(0,"Trailer.dds");
SetBufferTexture(1,"Minigun.dds");
SetBufferTexture(2,"mapeado/texturas/edificio_ruinas_original.dds"); --?
SetBufferTexture(3,"mapeado/texturas/asfalto.dds");
SetBufferTexture(4,"mapeado/texturas/muro.dds");
SetBufferTexture(5,"mapeado/texturas/casas.dds"); --?
SetBufferTexture(6,"mapeado/texturas/techo_casas.dds"); 
SetBufferTexture(7,"mapeado/texturas/concreto_edificio.dds"); --?


MODEL=
{ Model_add("Mommy.iqm"),
   Model_add("GIRL.iqm"),
Model_add("BOY.iqm"),
Model_add("CAT.iqm");
};



o=1
for i=8,NPCOFFSET-1 do
    spawnf(FSPAWN[o][1],FSPAWN[o][2],0,i-6,i,MODEL[o]);
    
    --print(FSPAWN[o][1] .. ". "..FSPAWN[o][2])

    VRAM_Buffer_fill(i,i,i,0);
    o=o+1;
end
SetBufferTexture(8,"ZombieMom.dds");
SetBufferTexture(9,"ZombieGirl.dds");
SetBufferTexture(10,"ZombieBoy.dds");
SetBufferTexture(11,"CAT.dds");


SetBufferTexture(12,"HumanWoman.dds");


Audio_Configure(4,16)
OVERWORLD = Audio_SoundFile_add("Claxonzombies.ogg",0,0,0);
OVERWORLD2 = Audio_SoundFile_add("Zombienvenidosamihogar.ogg",0,1,6);


--AI--

    PUNTOS = 0; WIN = 4;

    function FAMILY(caller)
	local PP = Entity_Get_Position(Jugador);	
	local CalP= Entity_Get_Position(caller);
	local DD = V2Distance(PP,CalP);


	if(DD<0.11) then
	    Entity_Teleport(caller,-1000,-1000);
	    PUNTOS = PUNTOS +1;
	    print("+1");

	    if(PUNTOS > WIN) then
		print("VICTORY");
		Entity_Teleport(0,0,0);
	    end
	end
    end

    function NPC(caller)
--	local X,Y = Entity_Get_Position_EXT(Jugador)
	--print(X .. "," .. Y)
--	Entity_Goto_EXT(caller,X,Y);



	local PP = Entity_Get_Position(Jugador);	
	local CalP= Entity_Get_Position(caller);
	local DD = V2Distance(PP,CalP);


	if(DD<0.14) then
	    local PP = Entity_Get_Position(0);	
	end

	if(DD<2) then

	    --print(DD)

	    local Node=Scene_Find_Node(CalP)
	    local Node2 = Scene_Find_Node(PP);

	    --print(Node)
	    --print(Node2)

	    local PATH = Path_Find(Node,Node2,0,PP);
	     Entity_Path_Set(caller,PATH);
	    local X,Y = Entity_Path_Get_XY(caller);
	    --print(X .. "," .. Y)
	    Entity_Goto_EXT(caller,X,Y)
	end
    end
    

    --Player--
    Minigun_Angle=0;
    Inverse = 1;
    TurnSpeed = 1.2;

    DEADZONE = 0.7
    angle = 180+30
    toggleCAM=false;
    toggleCAMEX=false;
	function PC_GetMov()
		
		

        --Keyboard Movement--
		local izq = (PhoAPI.GetKey(65)*1.0);
        local der = PhoAPI.GetKey(68)*1.0;
        local forw = PhoAPI.GetKey(87)*1.0;
        local backw = PhoAPI.GetKey(83)*1.0;

		local TR = (PhoAPI.GetKey(69)*1.0);
		local TL = (PhoAPI.GetKey(81)*1.0);

	--Joystick Movement--
	local JX = (PhoAPI.GetJoyAxis(0,0));
	local JY = (PhoAPI.GetJoyAxis(0,1));

	local JX2 = (PhoAPI.GetJoyAxis(0,3));
	local JY2 = (PhoAPI.GetJoyAxis(0,4));

	if(V2Length_EXT(JX,JY) > DEADZONE) then
	    der = JX;
	    backw = JY;
	end
	if(V2Length_EXT(JX2,JY2) <= DEADZONE) then
	    JX2=0;
	    JY2=0;
	end

	if(PhoAPI.GetJoyButton(0,0)==1) then
	    Audio_Sound_Set_Flag(OVERWORLD,3);
	else
	    Audio_Sound_Set_Flag(OVERWORLD,0);
	end

	 if(TR==0) then 
		TR =(PhoAPI.GetJoyAxis(0,5));
	 end

	 if (TL==0) then
	 	TL = (PhoAPI.GetJoyAxis(0,2));
	 end

	--Mouse Movement--
	local mX,mY = Get_Mouse();

	if(JX2==0) then
	    JX2=mX
	end
	if(JY2==0) then
	    JY2=mY
	end

        return forw-backw, izq-der, (TL-TR)*Inverse*TurnSpeed, JX2,JY2;
    end
    function PC_GetAct()
        local Act = PhoAPI.GetKey(65);

	local toggle = PhoAPI.GetJoyButton(0,5);

        return (Act==1), (toggle==1);
	end
	
	
	function PC (Caller)
		
        local Instance = Entity_Get_Instance(Caller);
        local X,Y = Entity_Get_Position_EXT(Caller);

		

		local M,T,Tri,MiniX,MiniY = PC_GetMov()
		
	if(M~=0 or T ~= 0) then
	    Entity_Set_Direction(Caller,angle-V2Degrees_EXT(T,M))

	    M = 1
	else
	    M = 0
	end
		
	

	local act, toggle = PC_GetAct();

	

       Entity_Movement(Caller,M,0);
       Entity_Movement(Minigun,0,0);
       X,Y=Entity_Get_Position_EXT(Caller);
       Entity_Teleport(Minigun,X,Y);
	Camera_Instance_Look(Jugador);
	Camera_Position(angle,0.8,0.9);

	

	if(V2Length_EXT(MiniX,MiniY) > 0) then
--	    Entity_Set_Direction(Minigun,angle-V2Degrees_EXT(-MiniX,-MiniY));
	    Minigun_Angle=	angle-V2Degrees_EXT(-MiniX,-MiniY);
	end


	    Entity_Set_Direction(Minigun,Minigun_Angle);
	angle=angle+Tri;

	if(toggle) then
	    if(toggleCAMEX == false) then
		toggleCAM = not toggleCAM;
	    end
	    toggleCAMEX = true;
	else
	    toggleCAMEX = false;
	end

if(toggleCAM) then
	Camera_Position(angle,0.01,1.3);
    end
    end
